package cz.vsb.jezek.tetris;
/*
 * Kostka.java
 *
 * Created on 6. z��� 2000, 22:53
 */
 


/** 
 *
 * @author  David Jezek
 * @version 
 */
public class Block extends Object {

  public static final int C = 1;
  public static final int I = 2;
  public static final int PL = 3;
  public static final int LL = 4;
  public static final int LS = 5;
  public static final int PS = 6;
  public static final int T = 7;
  
  public static final int ANGLE_0 = 0;
  public static final int ANGLE_90 = 1;
  public static final int ANGLE_180 = 2;
  public static final int ANGLE_270 = 3;
  
  private static int[][] square = {{C,C},
                                      {C,C}};

  private static int[][] shapeIAngle90 = {{I,I,I,I}};
  private static int[][] shapeIAngle0 = {{I},
                                 {I},
                                 {I},
                                 {I}};

  private static int[][] shapeRightLAngle0 = {{PL,0},
                                   {PL,0},
                                   {PL,PL}};
  private static int[][] shapeRightLAngle90 = {{0, 0, PL},
                                    {PL,PL,PL}};
  private static int[][] shapeRightLAngle180 = {{PL,PL},
                                     {0, PL},
                                     {0, PL}};
  private static int[][] shapeRightLAngle270 = {{PL,PL,PL},
                                     {PL,0, 0}};

  private static int[][] shapeLeftLAngle180 = {{LL,LL},
                                     {LL,0},
                                     {LL,0}};
  private static int[][] shapeLeftLAngle270 = {{LL,0, 0},
                                     {LL,LL,LL}};
  private static int[][] shapeLeftLAngle0 = {{0, LL},
                                   {0, LL},
                                   {LL,LL}};
  private static int[][] shapeLeftLangle90 = {{LL,LL,LL},
                                    {0, 0, LL}};

  private static int[][] shapeLeftSAngle0 = {{0, LS},
                                   {LS,LS},
                                   {LS,0}};
  private static int[][] shapeLeftSAngle90 = {{LS,LS, 0},
                                    {0, LS,LS}};
  private static int[][] shapeLeftSAngle180 = shapeLeftSAngle0;
  private static int[][] shapeLeftSAngle270 = shapeLeftSAngle90;

  private static int[][] shapeRightSAngle0 = {{PS, 0},
                                   {PS,PS},
                                   {0, PS}};
  private static int[][] shapeRightSAngle90 = {{0, PS, PS},
                                    {PS,PS,0}};
  private static int[][] shapeRightSAngle180 = shapeRightSAngle0;
  private static int[][] shapeRightSAngle270 = shapeRightSAngle90;

  private static int[][] shapeTAngle0 = {{T,T,T},
                                  {0,T,0}};
  private static int[][] shapeTAngle90 = {{T,0},
                                   {T,T},
                                   {T,0}};
  private static int[][] shapeTAngle180 = {{0,T,0},
                                    {T,T,T}};
  private static int[][] shapeTAngle270 = {{0,T},
                                    {T,T},
                                    {0,T}};


  private int[][][][] blocks = {{square,square,square,square},
                              {shapeIAngle0,shapeIAngle90,shapeIAngle0,shapeIAngle90},
                              {shapeRightLAngle0,shapeRightLAngle90,shapeRightLAngle180,shapeRightLAngle270},
                              {shapeLeftLAngle0,shapeLeftLangle90,shapeLeftLAngle180,shapeLeftLAngle270},
                              {shapeLeftSAngle0,shapeLeftSAngle90,shapeLeftSAngle180,shapeLeftSAngle270},
                              {shapeRightSAngle0,shapeRightSAngle90,shapeRightSAngle180,shapeRightSAngle270},
                              {shapeTAngle0,shapeTAngle90,shapeTAngle180,shapeTAngle270}};
  private int type;
  private int orientation;
  
  /** Creates new Block */
  public Block() {
    this.type = C;
    orientation = ANGLE_0;
  }
  
  public void setOrientation(int orientation)
  {
    this.orientation = orientation;
  }
  
  public int getOrientation()
  {
    return orientation;
  }
  
  public void setType(int type)
  {
    this.type = type;
  }
  
  public int getType()
  {
    return type;
  }

  public int[][] getShape()
  {
    return blocks[type-1][orientation];
  }
}