package cz.vsb.jezek.tetris;
/*
 * ImageAndText.java
 *
 * Created on 13. z��� 2000, 12:08
 */

import java.awt.*;

/**
 *
 * @author David Jezek
 * @version
 */
public class ImageAndText extends ImageComponent {

	/**
	 * 
	 */
	private static final long serialVersionUID = 3545803182329771577L;
	protected String text;
	protected int textX;
	protected int textY;
	/** Holds value of property textColor. */
	private Color textColor = Color.black;

	/** Creates new ImageAndText */
	public ImageAndText() {
	}

	public ImageAndText(Image img) {
		super(img);
	}

	public void setText(String text) {
		this.text = text;
		repaint();
	}

	@Override
	public void paint(Graphics g) {
		super.paint(g);
		if (text != null) {
			FontMetrics fm = this.getFontMetrics(getFont());
			int w = fm.stringWidth(text);
			int h = fm.getHeight();
			Dimension d = this.getSize();
			g.setColor(textColor);
			g.setFont(getFont());
			g.drawString(text, d.width / 2 - w / 2, d.height / 2 + h / 2);
		}
	}

	/**
	 * Getter for property textColor.
	 * 
	 * @return Value of property textColor.
	 */
	public Color getTextColor() {
		return textColor;
	}

	/**
	 * Setter for property textColor.
	 * 
	 * @param textColor New value of property textColor.
	 */
	public void setTextColor(Color textColor) {
		this.textColor = textColor;
	}
}