package cz.vsb.jezek.tetris;
/*
 * ImageComponent.java
 *
 * Created on 9. duben 2000, 15:15
 */

import java.awt.*;
import java.awt.image.*;

/**
 *
 * @author David Jezek
 * @version 1.0
 */
public class ImageComponent extends Component // Label
{

	/**
	 * 
	 */
	private static final long serialVersionUID = 3258128059516466481L;
	protected Image image;
	protected int w;
	protected int h;
	TetrisPanel tp;

	/** Creates new ImageComponent */
	public ImageComponent() {
	}

	public ImageComponent(Image img) {
		setImage(img, null);
	}

	@Override
	public Dimension getMaximumSize() {
		return getPreferredSize();
	}

	/**
	 * Getter for property prefferedSize.
	 * 
	 * @return Value of property prefferedSize.
	 */
	@Override
	public Dimension getPreferredSize() {
		if (image != null) {
			// int w = image.getWidth(this);
			// int h = image.getHeight(this);
			/*
			 * System.out.print(name); System.out.print(w); System.out.print(" ");
			 * System.out.println(h);
			 */
			/*
			 * if(w<0) w =0; if(h <0) h=0;
			 */
			return new Dimension(w, h);
		} else
			return new Dimension(10, 10);
	}

	@Override
	public Dimension getMinimumSize() {
		return getPreferredSize();
	}

	public void paint(Graphics g) {
		if (image != null) {
			g.drawImage(image, 0, 0, w, h, this);
		} else {
			g.setColor(Color.black);
			g.fillRect(0, 0, w, h);
		}
	}

	public void setImage(Image image, TetrisPanel tp) {
		this.tp = tp;
		this.image = image;
		boolean ok = this.prepareImage(this.image, this);
		if (ok) {
			synchronized (this) {
				w = image.getWidth(this);
				h = image.getHeight(this);
			}
			invalidate();
			repaint();
		}
	}

	public void setImage(String name) {
		Toolkit tk = Toolkit.getDefaultToolkit();
		setImage(tk.getImage(this.getClass().getResource(name)), null);
	}

	@Override
	public boolean imageUpdate(Image img, int infoflags, int x, int y, int width, int height) {
		if ((infoflags & ImageObserver.HEIGHT) != 0) {
			synchronized (this) {
				h = height;
			}
			invalidate();
		}
		if ((infoflags & ImageObserver.WIDTH) != 0) {
			synchronized (this) {
				w = width;
			}
			invalidate();
		}
		if ((infoflags & ImageObserver.ALLBITS) != 0) {
			return false;
		}
		return true;
	}

	@Override
	public void repaint() {
		Graphics g = this.getGraphics();
		if (g != null) {
			paint(g);
		}
	}
}