package cz.vsb.jezek.tetris;
/*
 * TetrisPanel.java
 *
 * Created on 12. z��� 2000, 1:00
 */
 
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.net.*;
import java.applet.*;

import javax.imageio.ImageIO;
/** 
 *
 * @author  David Jezek
 * @version 
 */
public class TetrisPanel extends java.awt.Panel implements ScoreListener{

  /**
	 * 
	 */
  private static final long serialVersionUID = 3257005475374838836L;
  private static BufferedImage[] square = new BufferedImage[7];
  private static BufferedImage background;
  private static BufferedImage urovenI;
  private static BufferedImage levelI;
  private static BufferedImage bodyI;
  private static BufferedImage scoreI;
  private static BufferedImage spaceI;
  private static BufferedImage newGameI;
  private static BufferedImage loader;
  private static BufferedImage loaderC;
  
  protected int loadedResource = 0;
  protected boolean loading;
  protected TetrisModel tm;
  protected boolean firstPaint = true;

  /** Creates new form TetrisPanel */
  public TetrisPanel() {
	try {
		loader = ImageIO.read(Tetris.class.getResourceAsStream("resources/loader0.gif"));
		loaderC = ImageIO.read(Tetris.class.getResourceAsStream("resources/loader1.gif"));
		
		square[0] = ImageIO.read(Tetris.class.getResourceAsStream("resources/c0.gif"));
		square[1] = ImageIO.read(Tetris.class.getResourceAsStream("resources/c1.gif"));
		square[2] = ImageIO.read(Tetris.class.getResourceAsStream("resources/c2.gif"));
		square[3] = ImageIO.read(Tetris.class.getResourceAsStream("resources/c3.gif"));
		square[4] = ImageIO.read(Tetris.class.getResourceAsStream("resources/c4.gif"));
		square[5] = ImageIO.read(Tetris.class.getResourceAsStream("resources/c5.gif"));
		square[6] = ImageIO.read(Tetris.class.getResourceAsStream("resources/c6.gif"));
		background = ImageIO.read(Tetris.class.getResourceAsStream("resources/bckg.gif"));
		urovenI = ImageIO.read(Tetris.class.getResourceAsStream("resources/uroven.gif"));
		levelI = ImageIO.read(Tetris.class.getResourceAsStream("resources/level.gif"));
		bodyI = ImageIO.read(Tetris.class.getResourceAsStream("resources/body.gif"));
		scoreI = ImageIO.read(Tetris.class.getResourceAsStream("resources/score.gif"));
		spaceI = ImageIO.read(Tetris.class.getResourceAsStream("resources/space.gif"));
		newGameI = ImageIO.read(Tetris.class.getResourceAsStream("resources/newgame1.gif"));
		tm = new TetrisModel();
		tetris1 = new Tetris(background, square);
		tm.setScoreListener(this);
		initComponents ();
		loadImages();
		endLoading();
	} catch (IOException e) {
		e.printStackTrace();
	}
  }
  
  public void loadImages()
  {
    loading = true;
    uroven.setImage(urovenI, this);
    level.setImage(levelI, this);
    body.setImage(bodyI, this);
    score.setImage(scoreI, this);
    space.setImage(spaceI, this);
    newGame.setImage(newGameI, this);
  }
  
  protected void endLoading()
  {
    loading = false;
    tm.setGameListener(tetris1);
    level.setTextColor(Color.red);
    Font f = new Font("Dialog", Font.PLAIN | Font.BOLD, 20);
    level.setFont(f);
    f = new Font("Dialog", Font.PLAIN | Font.BOLD,15);
    score.setFont(f);
    tetris1.setScoreListener(this);
    tetris1.initBuffers();
    doLayout();
    repaint();
    this.paintComponents(getGraphics());
    uroven.repaint();
    level.repaint();
    body.repaint();
    score.repaint();
    space.repaint();
    newGame.repaint();
  }

  /** This method is called from within the constructor to
   * initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is
   * always regenerated by the FormEditor.
   */
  private void initComponents () {
    uroven = new ImageComponent ();
    level = new ImageAndText ();
    body = new ImageComponent ();
    score = new ImageAndText ();
    space = new ImageComponent ();
    newGame = new ImageComponent ();
    setLayout (new java.awt.GridBagLayout ());
    java.awt.GridBagConstraints gridBagConstraints1;



    gridBagConstraints1 = new java.awt.GridBagConstraints ();
    gridBagConstraints1.gridheight = 0;
    add (tetris1, gridBagConstraints1);



    gridBagConstraints1 = new java.awt.GridBagConstraints ();
    gridBagConstraints1.gridwidth = 0;
    add (uroven, gridBagConstraints1);



    gridBagConstraints1 = new java.awt.GridBagConstraints ();
    gridBagConstraints1.gridwidth = 0;
    add (level, gridBagConstraints1);



    gridBagConstraints1 = new java.awt.GridBagConstraints ();
    gridBagConstraints1.gridwidth = 0;
    add (body, gridBagConstraints1);



    gridBagConstraints1 = new java.awt.GridBagConstraints ();
    gridBagConstraints1.gridwidth = 0;
    add (score, gridBagConstraints1);



    gridBagConstraints1 = new java.awt.GridBagConstraints ();
    gridBagConstraints1.gridwidth = 0;
    add (space, gridBagConstraints1);

    newGame.addMouseListener (new java.awt.event.MouseAdapter () {
      public void mouseClicked (java.awt.event.MouseEvent evt) {
        newGameMouseClicked (evt);
      }
    }
    );


    gridBagConstraints1 = new java.awt.GridBagConstraints ();
    gridBagConstraints1.gridwidth = 0;
    add (newGame, gridBagConstraints1);

  }

  private void newGameMouseClicked (java.awt.event.MouseEvent evt) {
  tm.endGame();
  new Thread(tm).start();
  }


  private Tetris tetris1;
  private ImageComponent uroven;
  private ImageAndText level;
  private ImageComponent body;
  private ImageAndText score;
  private ImageComponent space;
  private ImageComponent newGame;

  public void scoreChanged(long score) {
    this.score.setText(new Long(score).toString());
  }
  public void levelChanged(int level) {
    this.level.setText(new Integer(level).toString());
  }

  public void paint(Graphics g)
  {
    if(loading)
    {
      int x = getSize().width/2 - loader.getWidth(this)/2;
      int y = getSize().height/2 - loader.getHeight(this)/2;
      int ch = loaderC.getHeight(this);
      int cw = loaderC.getWidth(this);
      g.drawImage(loader, x, y, this);
      g.drawImage(loaderC, x, y, x+cw/16*loadedResource , y+ch,
                           0, 0, cw/16*loadedResource , ch, this);
    }
    else
      super.paint(g);
  }
  
  public synchronized void addLoadedResource()
  {
    loadedResource++;
    paint(getGraphics());
    if(loadedResource == 16)
      endLoading();
  }

  public Image getBackgroundImage() {
	  return background;
  }
  
  public TetrisModel getTetrisModel()
  {
    return tm;
  }
}